OnlineShop/Models/GoodViewModel.cs
using Microsoft.AspNetCore.Http;
using OnlineShop.DAL.Data.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Threading.Tasks;

namespace OnlineShop.Models
{
    public class GoodViewModel
    {
        public int Id { get; set; }
        public string Title { get; set; }

        [Column(TypeName = "decimal(18,2)")]
        [Range(0, 1000000, ErrorMessage = "Value for {0} must be between {1} and {2}.")]
        public decimal Price { get; set; }
        public string Description { get; set; }
        public Category Category { get; set; }
        public int CategoryId { get; set; }
        public IFormFile Image { get; set; }
    }
}

OnlineShop/Controllers/CartController.cs
using Microsoft.AspNetCore.Mvc;
using OnlineShop.DAL.Data.Models;
using OnlineShop.DAL.Services.Interfaces;
using OnlineShop.Helpers;
using OnlineShop.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace OnlineShop.Controllers
{
    public class CartController : Controller
    {
        private IGoodService _service;
        public CartController(IGoodService service)
        {
            _service = service;
        }
        public IActionResult Index()
        {
            var cart = SessionHelper.GetObjectFromJson<List<OrderItemViewModel>>(HttpContext.Session, "cart");

            if(cart == null)
            {
                cart = new List<OrderItemViewModel>();
            }

            ViewBag.totalPrice = cart.Select(i => i.Quantity * i.Good.Price).Sum();
            return View(cart);
        }

        public async Task<IActionResult> Buy(int id)
        {
            var cart = SessionHelper.GetObjectFromJson<List<OrderItemViewModel>>(HttpContext.Session, "cart");
            if (cart == null)
            {
                cart = new List<OrderItemViewModel>();
            }
            var good = await _service.GetByIdAsync(id);
            if (good == null)
            {
                return NotFound();
            }
            cart.Add(new OrderItemViewModel { Good = good, Quantity = 1, Id = cart.Count() });
            SessionHelper.SetObjectAsJson(HttpContext.Session, "cart", cart);
            return RedirectToAction("Index");
        }

        public IActionResult Delete(int id)
        {
            var cart = SessionHelper.GetObjectFromJson<List<OrderItemViewModel>>(HttpContext.Session, "cart");

            var item = cart.FirstOrDefault(i => i.Id == id);


            if (item == null)
            {
                return NotFound();
            }

            cart.Remove(item);
            SessionHelper.SetObjectAsJson(HttpContext.Session, "cart", cart);
            return RedirectToAction("Index");
        }

        // GET: Cart/Edit/5
        public IActionResult Edit(int id)
        {
            var cart = SessionHelper.GetObjectFromJson<List<OrderItemViewModel>>(HttpContext.Session, "cart");
            var cartItem = cart.FirstOrDefault(i => i.Id == id);
            if (cartItem == null)
            {
                return NotFound();
            }

            return View(cartItem);
        }

        // POST: Cart/Edit/5
        // To protect from overposting attacks, enable the specific properties you want to bind to.
        // For more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(int id, OrderItemViewModel orderItem)
        {
            if (ModelState.IsValid)
            {
                var cart = SessionHelper.GetObjectFromJson<List<OrderItemViewModel>>(HttpContext.Session, "cart");
                var cartItem = cart.FirstOrDefault(i => i.Id == id);
                if(cartItem == null)
                {
                    return NotFound();
                }
                cartItem.Quantity = orderItem.Quantity;
                SessionHelper.SetObjectAsJson(HttpContext.Session, "cart", cart);
                return RedirectToAction("Index");
            }
            return View(orderItem);
        }
    }
}

OnlineShop/Controllers/GoodsController.cs
using System;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using OnlineShop.DAL.Data;
using OnlineShop.DAL.Data.Models;
using OnlineShop.DAL.Services.Interfaces;
using OnlineShop.Models;

namespace OnlineShop.Controllers
{
    public class GoodsController : Controller
    {
        private readonly IGoodService _goodService;
        
        private readonly IWebHostEnvironment _webHostEnvironment;
        private readonly ICategoryService _categoryService;

        public GoodsController(IGoodService service, IWebHostEnvironment webHostEnvironment, ICategoryService categoryService)
        {
            _goodService = service;
            _webHostEnvironment = webHostEnvironment;
            _categoryService = categoryService;
        }

        // GET: Goods
        public async Task<IActionResult> Index()
        {
            var goods = await _goodService.GetAllAsync();
            return View(goods);
        }

        // GET: Goods/Details/5
        public async Task<IActionResult> Details(int? id)
        {
            if(id == null)
            {
                return RedirectToAction(nameof(Index));
            }

            var good = await _goodService.GetByIdAsync(id.Value);

            if (good == null)
            {
                return NotFound();
            }

            return View(good);
        }

        // GET: Goods/Create
        public async Task<IActionResult> Create()
        {
            //TODO write category service
            ViewData["CategoryId"] = new SelectList(await _categoryService.GetAllAsync(), "Id", "Title");
            //ViewData["CategoryId"] = new SelectList(_context.Set<Category>(), "Id", "Title");
            return View();
        }

        // POST: Goods/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to.
        // For more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(GoodViewModel model)
        {
            if (ModelState.IsValid)
            {
                string uniqueFileName = await UploadedFile(model);

                Good good = new Good
                {
                    Title = model.Title,
                    Price = model.Price,
                    Description = model.Description,
                    CategoryId = model.CategoryId,
                    Image = uniqueFileName
                };

                await _goodService.CreateAsync(good);
                return RedirectToAction(nameof(Index));
            }

            ViewData["CategoryId"] = new SelectList(await _categoryService.GetAllAsync(), "Id", "Title", model.CategoryId);
            //ViewData["CategoryId"] = new SelectList(_context.Set<Category>(), "Id", "Title", model.CategoryId);
            return View(model);
        }

        // GET: Goods/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if(id == null)
            {
                RedirectToAction(nameof(Index));
            }

            var good = await _goodService.GetByIdAsync(id.Value);
            
            if (good == null)
            {
                return NotFound();
            }

            var goodModel = new GoodViewModel
            {
                Id = good.Id,
                Title = good.Title,
                Description = good.Description,
                Category = good.Category,
                CategoryId = good.CategoryId,
                Price = good.Price,
                Image = await GetImage(good.Image)
            };

            TempData["file"] = good.Image;
            ViewData["CategoryId"] = new SelectList(await _categoryService.GetAllAsync(), "Id", "Title", good.CategoryId);
            //ViewData["CategoryId"] = new SelectList(_context.Set<Category>(), "Id", "Title", good.CategoryId);
            return View(goodModel);
        }

        // POST: Goods/Edit/5
        // To protect from overposting attacks, enable the specific properties you want to bind to.
        // For more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int? id, GoodViewModel model)
        {
            if(id == null)
            {
                RedirectToAction(nameof(Index));
            }

            if (id != model.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                string uniqueFileName = model.Image == null ? TempData["file"]?.ToString() : await UploadedFile(model);

                Good good = new Good
                {
                    Id = model.Id,
                    Title = model.Title,
                    Price = model.Price,
                    Description = model.Description,
                    CategoryId = model.CategoryId,
                    Image = uniqueFileName
                };

                await _goodService.UpdateAsync(good);
                return RedirectToAction(nameof(Index));
            }
            ViewData["CategoryId"] = new SelectList(await _categoryService.GetAllAsync(), "Id", "Title", model.CategoryId);
            //ViewData["CategoryId"] = new SelectList(_context.Set<Category>(), "Id", "Title", model.CategoryId);
            return View(model);
        }

        // GET: Goods/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if(id == null)
            {
                RedirectToAction(nameof(Index));
            }

            var good = await _goodService.GetByIdAsync(id.Value);
            
            if (good == null)
            {
                return NotFound();
            }

            return View(good);
        }

        // POST: Goods/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int? id)
        {
            if(id == null)
            {
                RedirectToAction(nameof(Index));
            }

            if (await _goodService.DeleteByIdAsync(id.Value))
            {
                return RedirectToAction(nameof(Index));
            }

            return BadRequest();
        }

        private async Task<string> UploadedFile(GoodViewModel model)
        {
            string uniqueFileName = null;

            if (model.Image != null)
            {
                string uploadsFolder = Path.Combine(_webHostEnvironment.WebRootPath, "images");
                uniqueFileName = Guid.NewGuid().ToString() + "_" + model.Image.FileName;
                string filePath = Path.Combine(uploadsFolder, uniqueFileName);
                using (var fileStream = new FileStream(filePath, FileMode.Create))
                {
                    await model.Image.CopyToAsync(fileStream);
                }
            }
            return uniqueFileName;
        }

        private async Task<IFormFile> GetImage(string path)
        {
            try
            {
                using var stream = new MemoryStream((await System.IO.File.ReadAllBytesAsync("wwwroot/images/" + path)).ToArray());
                var formFile = new FormFile(stream, 0, stream.Length, "streamFile", path.Split(@"\").Last());

                return formFile;
            }
            catch
            {
                return null;
            }
        }
    }
}

OnlineShop/Views/Goods/Create.cshtml
@model OnlineShop.Models.GoodViewModel

@{
    ViewData["Title"] = "Create";
}

<h1>Create</h1>

<h4>Good</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form enctype="multipart/form-data" asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Title" class="control-label"></label>
                <input asp-for="Title" class="form-control" />
                <span asp-validation-for="Title" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">Category</label>
                <select asp-for="CategoryId" class="form-control" asp-items="ViewBag.CategoryId"></select>
            </div>
            <div class="form-group">
                <label asp-for="Image" class="control-label"></label>
                <div class="custom-file">
                    <input asp-for="Image" class="custom-file-input" id="customFile">
                    <label class="custom-file-label" for="customFile">Choose file</label>
                </div>
                <span asp-validation-for="Image" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
    <script type="text/javascript">

        // Add the following code if you want the name of the file appear on select
        $(".custom-file-input").on("change", function () {
            var fileName = $(this).val().split("\\").pop();
            $(this).siblings(".custom-file-label").addClass("selected").html(fileName);
        });
    </script>
}

OnlineShop/Views/Goods/Delete.cshtml
@model OnlineShop.DAL.Data.Models.Good

@{
    ViewData["Title"] = "Delete";
}

<h1>Delete</h1>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Good</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Title)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Title)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Price)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Price)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Description)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Category)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Category.Id)
        </dd class>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="Id" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

OnlineShop/Views/Goods/Details.cshtml
@model OnlineShop.DAL.Data.Models.Good

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>Good</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Title)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Title)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Price)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Price)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Description)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Category)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Category.Title)
        </dd>
        <dd class="col-sm-2">
            <img src="~/images/@Model.Image" asp-append-version="true" width="100%" alt="@Model.Title"/>
            
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.Id">Edit</a> |
    <a asp-action="Index">Back to List</a>
</div>

OnlineShop/Views/Goods/Edit.cshtml
@model OnlineShop.Models.GoodViewModel
@{
    ViewData["Title"] = "Edit";
}

<h1>Edit</h1>

<h4>Good</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form enctype="multipart/form-data" asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Title" class="control-label"></label>
                <input asp-for="Title" class="form-control" />
                <span asp-validation-for="Title" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">Category</label>
                <select asp-for="CategoryId" class="form-control" asp-items="ViewBag.CategoryId"></select>
                <span asp-validation-for="CategoryId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Image" class="control-label"></label>
                <div class="custom-file">
                    <input asp-for="Image" class="custom-file-input" id="customFile">
                    <label class="custom-file-label" for="customFile">Choose file</label>
                </div>
                <span asp-validation-for="Image" class="text-danger"></span>
            </div>
            <input type="hidden" asp-for="Id" />
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
    <script type="text/javascript">

        // Add the following code if you want the name of the file appear on select
        $(".custom-file-input").on("change", function () {
            var fileName = $(this).val().split("\\").pop();
            $(this).siblings(".custom-file-label").addClass("selected").html(fileName);
        });
    </script>
}

OnlineShop/Views/Goods/Index.cshtml
@model IEnumerable<OnlineShop.DAL.Data.Models.Good>

@{
    ViewData["Title"] = "Index";
}

<h1>Index</h1>

<p>
    <a asp-action="Create">Create New</a>
</p>
<table class="table" id="goodTable">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Title)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Price)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Description)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Category)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Title)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Price)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Description)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Category.Title)
                </td>
                <td>
                    <a asp-controller="Cart" asp-action="Buy" asp-route-id="@item.Id">Add to cart</a> |
                    <a asp-action="Edit" asp-route-id="@item.Id">Edit</a> |
                    <a asp-action="Details" asp-route-id="@item.Id">Details</a> |
                    <a asp-action="Delete" asp-route-id="@item.Id">Delete</a>
                </td>
            </tr>
        }
    </tbody>
</table>

@section Scripts
{
    <script src="~/lib/datatables/js/jquery.dataTables.min.js"></script>
    <script src="~/lib/datatables/js/dataTables.bootstrap4.min.js"></script>
    <script>
        $(document).ready(function () {
            $('#goodTable').DataTable();
        });
    </script>
}